/*
 * Created on 26-oct-2004
 *
 * FIXME To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package es.aeat.pret.c200.mc.comun;

import java.io.File;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLDecoder;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * @author f00998k0
 * 
 *         To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public final class PathTrabajo {

    private static final String IMPOSIBLE_ENCONTRAR_EL_DIRECTORIO_DE_TRABAJO = "Imposible encontrar el directorio de trabajo";

	private static String codeSource = null;

    private static URL urlCodeSource = null;

    private static String pluginHome;

    private static String pathTrabajoURL;

    private static String pathTrabajoSinProtocolo;
    static {
        try {
            new PathTrabajo();
        } catch (MalformedURLException e) {
            Logger.getLogger(PathTrabajo.class.getName()).log(Level.SEVERE,
                    IMPOSIBLE_ENCONTRAR_EL_DIRECTORIO_DE_TRABAJO, e);
        }
    }

    private PathTrabajo() throws MalformedURLException {
        try {
            urlCodeSource = getClass().getProtectionDomain().getCodeSource()
                    .getLocation();
            codeSource = URLDecoder.decode(urlCodeSource.toString(), "UTF-8");

            pluginHome = System.getProperty("plugin.home");
        } catch (UnsupportedEncodingException e) {
            Logger.getLogger(PathTrabajo.class.getName()).log(Level.SEVERE,
                    IMPOSIBLE_ENCONTRAR_EL_DIRECTORIO_DE_TRABAJO, e);

        }
    }

    public static String getPathTrabajoComoURL() {
        if (pathTrabajoURL == null) {
            if (pluginHome != null) {
                pathTrabajoURL = new File(pluginHome).toURI().toASCIIString();
            } else {
                pathTrabajoURL = new File(getPathTrabajoSinProtocolo()).toURI().toASCIIString();

            }
        }
        return pathTrabajoURL;
    }

    public static String getPathTrabajoSinProtocolo() {
        if (pathTrabajoSinProtocolo == null) {
            if (pluginHome != null) {
                pathTrabajoSinProtocolo = pluginHome;

                if (!pathTrabajoSinProtocolo.endsWith(File.separator)) {
                    pathTrabajoSinProtocolo += File.separator;
                }

            } else {
                String codeSourceSinProtocolo = null;
                try {
                    codeSourceSinProtocolo = new File(new URL(codeSource).getPath()).getCanonicalPath();
                } catch (IOException e) {
                    Logger.getLogger(PathTrabajo.class.getName()).log(
                            Level.SEVERE,
                            IMPOSIBLE_ENCONTRAR_EL_DIRECTORIO_DE_TRABAJO, e);
                }

                // ADM. 14.11.2011: 
                // Si codeSourceSinProtocolo ya es un directorio me lo quedo tal cual
                // si no, le quito la parte final (que es un archivo).
                if (codeSourceSinProtocolo!=null && !new File(codeSourceSinProtocolo).isDirectory()) {
                    int lastIndex = codeSourceSinProtocolo.lastIndexOf(File.separator);
                    if (lastIndex != -1) {
                        pathTrabajoSinProtocolo = codeSourceSinProtocolo.substring(0, lastIndex + 1);
                    }
                } else {
                    pathTrabajoSinProtocolo = codeSourceSinProtocolo;
                }

                if (pathTrabajoSinProtocolo!=null && !pathTrabajoSinProtocolo.endsWith(File.separator)) {
                    pathTrabajoSinProtocolo += File.separator;
                }
            }
        }
        return pathTrabajoSinProtocolo;
    }
}